// Test Programm fr die Gex Library
// DirectX6.0 Include Dateien
#include <ddraw.h>
#include <d3d.h>

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <assert.h>
#include <string.h>
#include <math.h>
#include <malloc.h>
#include <time.h>
#include <windows.h>
#include <windowsx.h>
#include <stdarg.h>
#include <fcntl.h>
#include <io.h>
#include <stdio.h>
#include <math.h>
#include "gex21.h"
_device3d device3d;
#include "gex_uo.h"

#define PI 3.141592654

HWND hWnd;
LPDIRECTDRAWSURFACE4 texturesurface;
LPDIRECT3DTEXTURE2 texture;

struct overlay_map {
    int x;
    int y;
    WORD object;
    signed char type1;
};

struct static_map {
    WORD object;
    BYTE x;
    BYTE y;
    signed char height;
    WORD unknown;
};

struct nstatic_map {
    WORD object;
    int x;
    int y;
    signed char height;
};

overlay_map omap[100000];
int omap_pos = 0;

// Original Static Objekte
nstatic_map o_smap[10000];
int o_smap_pos = 0;

// Genderte Static Objekte
nstatic_map c_smap[100000];
int c_smap_pos = 0;

nstatic_map akt_static;

struct artidx_structure {
    int position;
    int size;
    int unknown;
};

artidx_structure artidx;

// Map Strukturen
struct tPlate {
    char d1;
    char d2;
    char d3;
};

struct tBlock {
    int head;
    tPlate Plates[8][8];
};

struct tstatic {
    char d0;
    char d1;
    char d2;
    char d3;
    char d4;
    char d5;
    char d6;
};

void * Map_Ground;

tBlock Block;

int perspektive = 0;
int static_on = FALSE;
int editmode = FALSE;

BOOL static_z = FALSE; 

LPDIRECTDRAWSURFACE4 tilesurface[4096];
LPDIRECT3DTEXTURE2 tile[4096];
int tile_anzahl = 4096;

int static_anzahl = 100;
int static_pos = 0;
int static_objects[100];
WORD static_xsize[100];
WORD static_ysize[100];
WORD st_xsize;
WORD st_ysize;
LPDIRECTDRAWSURFACE4 staticsurface[100];
LPDIRECT3DTEXTURE2 statictexture[100];

/*
void * tiles_in_mem[81920];
BOOL is_tile_in_mem[81920];*/
BOOL reload_it;
int xdim = 30;
int ydim = 30;

int mousex;
int mousey;
BOOL mouseclick;

int mmove_add;
int whatmouse;
signed char original_pos;
WORD original_object;
int akt_tile;

// Uo3dmv Daten
Vertex3D p1;
Vertex3D p2;
Vertex3D p3;
Vertex3D p4;

WORD * wmap_ptr;
WORD map_pixelnr;
char * map_ptr;
signed char * map_ptrsc;
signed int map_high1;
signed int map_high2;
signed int map_high3;
signed int map_high4;
int ix;
int handle;
int iy;
int world_xpos;
int world_ypos;
int view_zpos;
int view_ypos;
char a;
float arot;
float brot;
float crot;
int mittex;
int mittey;

int save1_x;
int save1_y;
int save2_x;
int save2_y;
int save3_x;
int save3_y;


void * tile_memory;
void * tile_transform_memory;
void * tile_scale_memory;
void * static_memory;
int copymatrix[10000];
int aktzahl = 4;
int maxzahl = 44;  
int status = 1;
int addmatrix[100][100];

// Editor einstellungen
char riselevel = 1;
signed char mhheight;
int drawmode = 1;
int tilepos = 0;
int qualitytiles = TRUE;
BOOL staticmode = FALSE;

int cfg_driver;
int cfg_mode;
int cfg_tile;
int cfg_static;
int cfg_zbuffer;

void render_matrixzahl() {
    if ( status == 1 ) aktzahl = aktzahl + 2;
    if ( status == 2 ) aktzahl = aktzahl - 2;
    if ( status == 4 ) {
        aktzahl = aktzahl-1;
        status = 2;
    }     
    if ( status == 3 ) {
        aktzahl = aktzahl+1;
        status = 4;
    }
    if ( status == 1 ) if ( aktzahl == maxzahl ) status = 3;
    if ( aktzahl == 4 ) status = 1;  
}

void make_addmatrix() {
     int ix;
     int iy;
     int i = 0;
     for ( iy = 0; iy != 22; iy++ ) 
     for ( ix = 0; ix != 43 ; ix++ ) {   
         addmatrix[ix][iy] = aktzahl;
         render_matrixzahl();
     }
}


void make_readmatrix() {
    int i;  
    int desti = 0;
    int xstartpos = 2;
    int laufpos = 0;
    int aktuellesy = 1;
    int addzahl = 0;
    int ix;
    for ( i = 0 ; i != 22 ; i++ ) {
        xstartpos = xstartpos + addzahl;
        laufpos = xstartpos;
        addzahl = addzahl + 2;
        // Eine Row bertragen
        for ( ix = 0; ix != 22; ix++ ) {  
            copymatrix[desti] = laufpos;
            laufpos = laufpos + addmatrix[ix][aktuellesy-1];
            desti++;
        }  
        aktuellesy++;
    }
}

void gpoint3(WORD *bild, int x, int y,  WORD data) {
    bild[y*128+x] = data;
}

void transform_tile() {
    WORD * source;
    WORD * dest;
    int ix;
    int iy;
    int desti = 0;
    int xstartpos = 0;
    int laufpos = 0;
    int aktuellesy = 1;
    int addzahl;
    source = (WORD*) tile_memory;
    dest = (WORD*) tile_transform_memory;
    make_readmatrix();
    for ( iy = 0 ; iy != 1024 ; iy++ ) {
        dest[iy] = source[copymatrix[iy]];   
    }
}


void Convert_to_32x32( void * source , void * dest ) {
    WORD * source2;
    WORD * dest2;
    float posx = 0;
    float posy = 0;
    float addx;
    float addy;
    int ix;
    int iy;
    int i = 0;
    source2 = (WORD*) source;
    dest2 = (WORD*) dest;
    addx = (float)22/cfg_tile;//0.6875;
    addy = (float)22/cfg_tile;//0.6875;
    for ( iy = 0; iy < cfg_tile; iy++ ) { 
        for ( ix = 0; ix < cfg_tile; ix++ ) {
            dest2[i] = source2[(int) ((((int)posy)*22)+(posx) )];
            posx += addx;
            i++;
        }
        posy += addy;
        posx = 0;
    }
}

void dekompress( unsigned short int * source , unsigned short int * dest ) {
   int i;
   int irun;
   int idest;
   int iy;
   unsigned short int run;
   i = 49;
   idest = 0;
   for ( iy = 0; iy < 44; iy++) {
       run = source[i];
       i++;
       for (irun = 0; irun < run; irun++) {
           dest[idest] = source[i];
           idest++;
           i++;
       }
       i++;
       i++;
       i++;
   }
}

void artidx_load_tile ( int Nr ) {
    int handle;
    WORD datasize;
    WORD trigger;
    handle = open("artidx.mul", O_RDONLY | O_BINARY );
    lseek(handle, Nr * 12  , SEEK_SET );
    read(handle,&artidx, 12 );
    close( handle );
    handle = open("art.mul", O_RDONLY | O_BINARY );
    lseek(handle, artidx.position  , SEEK_SET );
    read(handle, tile_memory , artidx.size );
    close( handle );
}

void artidx_load_static ( WORD Nr , int pos) {
    int handle;
    WORD offset[2000];
    int type;
    WORD width;
    WORD height;
    WORD datasize;
    WORD offrun;
    WORD xpos;
    WORD runs;
    WORD * data_source;
    WORD * bild;
    WORD * source2;
    WORD * dest2;
    int i2;
    int i;
    WORD iy;
    WORD ix;
    WORD runlenght;
    WORD runlenghtcount;
    BOOL noexit;
    handle = open("artidx.mul", O_RDONLY | O_BINARY );
    lseek(handle, (12*16384) + ( Nr * 12)  , SEEK_SET );
    read(handle,&artidx, 12 );
    close( handle );
    
    handle = open("art.mul", O_RDONLY | O_BINARY );
    lseek(handle, artidx.position  , SEEK_SET );
    read(handle,&type,4);
    read(handle,&width,2);
    read(handle,&height,2);

    static_xsize[pos] = width;
    static_ysize[pos] = height;
  
    data_source = (WORD*) static_memory;
    bild = (WORD*) tile_transform_memory;
   
     if ( width != 0 ) if ( height != 0 )
     if ( width < 1024 ) if ( height < 1024 )  {
        ZeroMemory( tile_transform_memory, (width*height)*2 );
        read(handle,&offset,height*2);
        read(handle,static_memory,artidx.size);
        close( handle );
        for ( iy = 0; iy != height;iy++ ) {
           offrun = offset[iy];         
           xpos = 0;
           runs = 0;
           noexit = TRUE;     
            while ( noexit ) {    
                xpos = runs+xpos + data_source[offrun];
                offrun++;
                runs = data_source[offrun];
                offrun++; 
                if (runs == 0) noexit = FALSE; else
                    for ( ix = xpos; ix != (xpos+runs);ix++) {
                        bild[iy*width+ix] = data_source[offrun];
                        offrun++;
                    }
            }      
        }     
     }

    // auf 32x32 konvertieren
    source2 = (WORD*) tile_transform_memory;
    dest2 = (WORD*) tile_scale_memory;
    
    float posx = 0;
    float posy = 0;
    float addx;
    float addy;
    i = 0;
    
    addx = (float) width/cfg_static;
    addy = (float) height/cfg_static;
    for ( iy = 0; iy < cfg_static; iy++ ) { 
        for ( ix = 0; ix < cfg_static; ix++ ) {
            dest2[i] = source2[(int) ((((int)posy)*width)+(posx) )];
            posx += addx;
            i++;
        }
        posy += addy;
        posx = 0;
    }
      
}

// Routinene fr die Karte

void gpoint2(char *bild, int x, int y,   char d1, char d2, char d3) {
    bild[y*960+(x*3)] = d1;
    bild[y*960+(x*3)+1] = d2;
    bild[y*960+(x*3)+2] = d3;
}

void gpoint8(char *bild, int x, int y,   char d3) {
    bild[y*960+(x*3)+2] = d3;
}

char gpoint_testhigh(char *bild, int x, int y) {
    return bild[y*960+(x*3)+2];
}

void gpoint4(char *bild, int x, int y,  unsigned short int d1, char d3) {
    bild[y*960+(x*3)] = ( unsigned short int )  d1;
    bild[y*960+(x*3)+3] = d3;
}

void draw_block( int xpos, int ypos, tBlock Block ) {
    int ix;
    int iy;
    for (iy = 0; iy != 8; iy++)
      for (ix = 0; ix != 8; ix++) {
          gpoint2((char*)Map_Ground, xpos+ix, ypos+iy,
          Block.Plates[iy][ix].d1 ,Block.Plates[iy][ix].d2 , Block.Plates[iy][ix].d3 );
      }
}

void load_mapdata(int x, int y) {
    int ix;
    int iy;
    int handle;
    handle = open("Map0.mul", O_RDONLY | O_BINARY );
    for ( iy = 0 ; iy != (ydim/8)+1 ; iy++ ) {
        for ( ix = 0; ix != (xdim/8)+1 ; ix++ ) {
            lseek(handle,  ((ix+x)*100352)+ ((iy+y) * 196) , SEEK_SET );
            read(handle,&Block, 196 );       
            draw_block( ix*8 , iy*8 , Block );
        }
    }
    close( handle );
}

void load_staticdata(int x, int y) {
    int ix;
    int iy;
    int i;
    int handle_idx;
    int handle;
    int start_pos;
    int length;
    static_map data;
    handle_idx = open("Staidx0.mul", O_RDONLY | O_BINARY );
    handle = open("Statics0.mul", O_RDONLY | O_BINARY );   
    for ( iy = 0 ; iy != (ydim/8)+1 ; iy++ ) {
        for ( ix = 0; ix != (xdim/8)+1 ; ix++ ) {
             lseek(handle_idx, (ix+x)*(12*512) + ( (iy+y) * 12 ) , SEEK_SET );
             read(handle_idx,&start_pos, 4 );
             read(handle_idx,&length, 4 ); 
             if ( start_pos != -1 ) {
                 lseek(handle,  start_pos , SEEK_SET );
                 //read(handle,&staticdata, length );   
                 for ( i = 0 ; i < ( length/7)  ; i++ ) {
                       read( handle, &data , 7 );
                       o_smap[o_smap_pos].x = ((x+ix)*8)+data.x;
                       o_smap[o_smap_pos].y = ((y+iy)*8)+data.y;
                       o_smap[o_smap_pos].object = data.object;
                       o_smap[o_smap_pos].height = data.height;
                       o_smap_pos++;
                 }
             }
        }
    }
    close( handle );
    close ( handle_idx );
}






void load_tiles() {
    WORD * bild2;
    WORD * bild3;
    void * bild;
    DDSURFACEDESC2 ddsd;
    int i;
    int i2;
    int i3;   
   for ( i3 = 0; i3 < 1500; i3++ ) {   
        artidx_load_tile(i3);
        transform_tile();
        Convert_to_32x32 ( tile_transform_memory , tile_scale_memory );
        device3d.gettxtsurface(&tilesurface[i3] , cfg_tile , cfg_tile , 16 );   
        device3d.load(tilesurface[i3],&tile[i3]);
        tile[i3]->Load(tile[i3]);   
        ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
        ddsd.dwSize         = sizeof(DDSURFACEDESC2);
        tilesurface[i3]->Lock(NULL,&ddsd, DDLOCK_WAIT , 0);
        bild = ddsd.lpSurface;
        bild2 = (WORD*) bild;
        bild3 = (WORD*) tile_scale_memory;
        for (i = 0;i < cfg_tile*cfg_tile ;i++) {
            *bild2 = *bild3;
            bild2++;
            bild3++;
        }
        tilesurface[i3]->Unlock(NULL);
        device3d.settexture(tile[i3]);
   }
}

void load_quality_tiles() {
   WORD * bild2;
   WORD * bild3;
   unsigned int start;
   unsigned int lenght;
   int unused;
   int handle_idx;
   int handle_tex;
   handle_idx = open("texidx.mul", O_RDONLY | O_BINARY );
   handle_tex = open("texmaps.mul", O_RDONLY | O_BINARY ); 
   void * bild;
   DDSURFACEDESC2 ddsd;
   int i;
   int i2;
   for ( i = 0; i < 4095; i++ ) {   
        read(handle_idx, &start , 4);
        read(handle_idx, &lenght , 4);
        read(handle_idx, &unused , 4);
        if ( start != 0xFFFFFFFF ) {
             lseek(handle_tex, start  , SEEK_SET );
             read(handle_tex, tile_memory , lenght);
             if ( lenght == 0x2000 ) {
                 device3d.gettxtsurface(&tilesurface[i] , 64 , 64 , 16 );
                 device3d.load(tilesurface[i],&tile[i]);
                 tile[i]->Load(tile[i]);   
                 ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
                 ddsd.dwSize         = sizeof(DDSURFACEDESC2);
                 tilesurface[i]->Lock(NULL,&ddsd, DDLOCK_WAIT , 0);               
                 bild = ddsd.lpSurface;
                 bild2 = (WORD*) bild;
                 bild3 = (WORD*) tile_memory;
                 for (i2 = 0;i2 < 0x1000;i2++) {
                     //*bild2 = *bild3 << 1;
                     *bild2 = *bild3;
                     bild2++;
                     bild3++;
                 }
                 tilesurface[i]->Unlock(NULL); 
             }
             if ( lenght == 0x4000 ) {
                 device3d.gettxtsurface(&tilesurface[i] , 128 , 128 , 16 );
                 device3d.load(tilesurface[i],&tile[i]);
                 tile[i]->Load(tile[i]);   
                 ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
                 ddsd.dwSize         = sizeof(DDSURFACEDESC2);
                 tilesurface[i]->Lock(NULL,&ddsd, DDLOCK_WAIT , 0);               
                 bild = ddsd.lpSurface;
                 bild2 = (WORD*) bild;
                 bild3 = (WORD*) tile_memory;
                 for (i2 = 0;i2 < 0x2000;i2++) {
                     //*bild2 = *bild3 << 1;
                     *bild2 = *bild3;
                     bild2++;
                     bild3++;
                 }
                 tilesurface[i]->Unlock(NULL); 
             }
             
           }
        }
   close( handle_idx );
   close( handle_tex );
}

void load_onetiles(int nr) {
    WORD * bild2;
    WORD * bild3;
    WORD dummy;
    void * bild;
    DDSURFACEDESC2 ddsd;
    int i;
    int i2;
    int i3;
        artidx_load_tile(nr);
        transform_tile();
        Convert_to_32x32 ( tile_transform_memory , tile_scale_memory );       
        device3d.gettxtsurface(&tilesurface[1] , 32 , 32 , 16 );      
        device3d.load(tilesurface[1],&tile[1]);
        tile[1]->Load(tile[1]);
        ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
        ddsd.dwSize         = sizeof(DDSURFACEDESC2);
        tilesurface[1]->Lock(NULL,&ddsd, DDLOCK_WAIT , 0);
        bild = ddsd.lpSurface;
        bild2 = (WORD*) bild;
        bild3 = (WORD*) tile_scale_memory;
  
        for (i = 0;i < 1024;i++) {  
           /**bild2 = *bild3 << 1;
            bild2++;
            bild3++;*/
            *bild2 = *bild3;
            bild2++;
            bild3++;
        }
        tilesurface[1]->Unlock(NULL);
        device3d.settexture(tile[1]);
}

BOOL  is_mouse_in_triangle2 ( float x1, float y1, float x2, float y2, float x3, float y3,float mpx, float mpy ) {
    BOOL IsIn = FALSE;
    float dummy;

    float d1;
    float d2;
    float d3;
    float s1;
    float s2;
    float s3;
    float x1run;
    float x2run;
    int i;

  

    // Sortierungen
    if ( y1 > y2 ) {
        dummy = y2;
        y2 = y1;
        y1 = dummy;
        
        dummy = x2;
        x2 = x1;
        x1 = dummy;
    }

    if ( y1 > y3 ) {
        dummy = y3;
        y3 = y1;
        y1 = dummy;
        
        dummy = x3;
        x3 = x1;
        x1 = dummy;
    }

      if ( y2 > y3 ) {
        dummy = y2;
        y2 = y3;
        y3 = dummy;
        
        dummy = x2;
        x2 = x3;
        x3 = dummy;
    }

    // Lngenermittlungen
    d1 = y3-y1;
    d2 = y2-y1;
    d3 = y3-y2; 

    s1 = (x3-x1) / d1 ;  
    s2 = (x2-x1) / d2;
    s3 = (x3-x2) / d3;

    x1run = x1;
    x2run = x1;

    // Erster Bereichstest
    if ( mpy < y1 ) return FALSE;
    if ( mpy > y3 ) return FALSE;


    // Oberer Teil;
    for ( i = 0; i < d2;i++ ) {
         x1run = x1run + s1;
         x2run = x2run + s2;
         if (s2 >= 0 ) if ( x1run > mpx ) if ( x2run < mpx ) IsIn = TRUE;
         if (s2 < 0 ) if ( x1run < mpx ) if ( x2run > mpx ) IsIn = TRUE;
    }


    // Unterer Teil;
    for ( i = 0; i < d3;i++ ) {
         x1run = x1run + s1;
         x2run = x2run + s3;
         if (s3 >= 0 ) if ( x1run > mpx ) if ( x2run < mpx ) IsIn = TRUE;
         if (s3 < 0 ) if ( x1run < mpx ) if ( x2run > mpx ) IsIn = TRUE;
    }

    return IsIn;
}

BOOL  is_mouse_in_triangle ( float x1, float y1, float x2, float y2, float x3, float y3,float mpx, float mpy ) {
    float a;
    float b;
    float c;
    BOOL ergebnis; 
   /* a = (x1-mpx)*(y2-mpy)-(x2-mpx)*(y1-mpy);
    b = (x1-mpx)*(y3-mpy)-(x3-mpx)*(y1-mpy);
    c = (x2-mpx)*(y3-mpy)-(x3-mpx)*(y2-mpy);*/
    a = (mpx-x1)*(mpy-y2)-(mpx-x2)*(mpy-y1);
    b = (mpx-x1)*(mpy-y3)-(mpx-x3)*(mpy-y1);
    c = (mpx-x2)*(mpy-y3)-(mpx-x3)*(mpy-y2);
    //ergebnis = TRUE;
    if ( a*b < 0 )
     if ( a*c > 0 )
    /*  if ( a*(a-b+c) < 0 )
       if ( a*b*c*(a-b+c) > 0 )*/ ergebnis = TRUE;

   return ergebnis;
}

void drawit2() {

    device3d.settexture(tile[1]);
    
    D3DTLVERTEX v1;
    D3DTLVERTEX v2;
    D3DTLVERTEX v3;
    D3DTLVERTEX v4;
    
    v1.sx = 0;
    v1.sy = 0;
    v1.sz = -5;
    v1.rhw = 2;
    v1.color = RGB_MAKE(255,255,255);
    v1.specular = RGB_MAKE(255,255,255);
    v1.tu = 0;
    v1.tv = 0;
    
    v2.sx = 320;
    v2.sy = 0;
    v2.sz = -5;
    v2.rhw = 2;
    v2.specular = RGB_MAKE(255,255,255);
    v2.color = RGB_MAKE(255,255,255);
    v2.tu = 1;
    v2.tv = 0;
    
    v3.sx = 0;
    v3.sy = 320;
    v3.sz = -5;
    v3.rhw = 2;
    v3.specular = RGB_MAKE(255,255,255);
    v3.color = RGB_MAKE(255,255,255);
    v3.tu = 0;
    v3.tv = 1;

    v4.sx = 320;
    v4.sy = 320;
    v4.sz = -5;
    v4.rhw = 2;
    v4.specular = RGB_MAKE(255,255,255);
    v4.color = RGB_MAKE(255,255,255);
    v4.tu = 1;
    v4.tv = 1;
    
    device3d.drawtriangle ( v1,v2,v3 );
    device3d.drawtriangle ( v3,v2,v4 );

    device3d.flip();
}

// Datafile speichern
void save_datafile() {
    int i;
    int handle;
    int data;
    handle = open("data.omp", O_RDWR | O_CREAT | O_BINARY );
    // Header
    data = 8;
    write(handle, &data , 4);
    data = 12 + (omap_pos*11);
    write(handle, &data , 4);
    
    // Map0.mul Vernderungen
    write(handle, &omap_pos, 4 );
    write(handle, &omap, omap_pos*11 );

     // Static.mul Vernderungen
    write(handle, &c_smap_pos, 4 );
    write(handle, &c_smap, c_smap_pos*16 );
    
    close( handle );
}

// Datafile laden
void load_datafile() {
    int i;
    int handle;
    int data_map;
    int data_static;
    
    handle = open("data.omp",  O_RDONLY | O_BINARY);
    read(handle, &data_map, 4 );
    read(handle, &data_static, 4 );
    
    lseek(handle, data_map , SEEK_SET );
    read(handle, &omap_pos, 4 );
    read(handle, &omap, omap_pos*11 );

    lseek(handle, data_static , SEEK_SET );
    read(handle, &c_smap_pos, 4 );
    read(handle, &c_smap, c_smap_pos*16 );

    close( handle );
}

// Static Speicher initialisieren
void static_settile(WORD Nr) {
    WORD * bild2;
    WORD * bild3;
    void * bild;
    DDSURFACEDESC2 ddsd;
    int i5;
    int i;
    int i2;
    int i3;
    BOOL IsThere;
    int Where;

    IsThere = FALSE;
    // berprfen ob es schon vorhanden ist
    for ( i5 = 0;i5 < static_anzahl;i5++) {
        if ( static_objects[i5] == Nr ) {
            IsThere = TRUE;
            Where = i5;
        }
    }
    if ( IsThere ) {
        device3d.settexture(statictexture[Where]);
        st_xsize = static_xsize[Where];
        st_ysize = static_ysize[Where];
        return;
    } else {
        artidx_load_static( Nr , static_pos );
    
        if ( staticsurface[static_pos] != NULL ) {
            staticsurface[static_pos]->Release();
            staticsurface[static_pos] = NULL;
        }
        device3d.gettxtsurface(&staticsurface[static_pos] , cfg_static , cfg_static , 16 );
        device3d.setcolorkey( staticsurface[static_pos] , 0x0 );
        device3d.load(staticsurface[static_pos],&statictexture[static_pos]);
        statictexture[static_pos]->Load(statictexture[static_pos]);   
        ZeroMemory( &ddsd, sizeof(DDSURFACEDESC2) );
        ddsd.dwSize         = sizeof(DDSURFACEDESC2);
        staticsurface[static_pos]->Lock(NULL,&ddsd, DDLOCK_WAIT , 0);
        bild = ddsd.lpSurface;
        bild2 = (WORD*) bild;
        bild3 = (WORD*) tile_scale_memory;
        for (i = 0;i < cfg_static*cfg_static;i++) {
            *bild2 = *bild3;
            bild2++;
            bild3++;
        }
        staticsurface[static_pos]->Unlock(NULL);
        device3d.settexture(statictexture[static_pos]);
        static_objects[static_pos] = Nr;
        st_xsize = static_xsize[static_pos];
        st_ysize = static_ysize[static_pos]; 
        if (static_pos < static_anzahl-1 ) {
            static_pos++;
        } else {
            static_pos = 0;
        }
        
    }
}

// Message Verwaltung
long FAR PASCAL WndProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {

    char taste;
    int xpos;
    int ypos;
    int fwkey;
    
    switch( message) {

        case WM_LBUTTONUP:
                 mouseclick = FALSE;
                 mousex = LOWORD(lParam);  
                 mousey = HIWORD(lParam);  
          break;

          case WM_RBUTTONUP:
                 mouseclick = FALSE;
                 mousex = LOWORD(lParam);  
                 mousey = HIWORD(lParam);  
          break; 

        case WM_LBUTTONDOWN:
                 mouseclick = TRUE;
                 whatmouse = 1;
                 mousex = LOWORD(lParam);  
                 mousey = HIWORD(lParam);  
          break;

          case WM_RBUTTONDOWN:
                 mouseclick = TRUE;
                 whatmouse = 2;
                 mousex = LOWORD(lParam);  
                 mousey = HIWORD(lParam);  
          break; 

         case WM_MOUSEMOVE:                
                 mousex = LOWORD(lParam);  
                 mousey = HIWORD(lParam);  
          break; 

          case WM_KEYDOWN:
               switch( wParam ) {
                      case VK_ESCAPE:
                             PostMessage( hWnd, WM_CLOSE,0,0);

                      case VK_F1:    // Normal Mode
                         if ( editmode ) editmode = FALSE;
                         if ( staticmode ) staticmode = FALSE;
                         xdim = 30;
                         ydim = 30;
                         reload_it = TRUE;
                      break;

                      case VK_F2:    // Edit Mode
                          if ( editmode ) editmode = FALSE;
                               else {
                                   staticmode = FALSE;
                                   editmode = TRUE;
                                   perspektive = 3;
                                   xdim = 15;
                                   ydim = 15;
                                   view_zpos = -300;
                               }
                           reload_it = TRUE;    
                      break;

                      case VK_F3:    // Static Mode
                          if ( staticmode ) staticmode = FALSE;
                               else {
                                   editmode = FALSE;
                                   staticmode = TRUE;
                                   perspektive = 5;                 
                                   view_zpos = -300;
                               }
                          reload_it = TRUE;     
                      break;

                      case VK_F5:     // Perspektive 0
                             perspektive = 0;
                           break;

                      case VK_F6:     // Perspektive 1
                             perspektive = 1;
                           break;

                      case VK_F7:     // Perspektive 2
                             perspektive = 2;
                           break;

                      case VK_F8:     // Perspektive 3
                             perspektive = 3;
                           break;

                       case VK_F11:    // Datenfile sichern
                             save_datafile();
                           break;
                           
                       case VK_F12:      // Datenfile laden
                             load_datafile();
                           break;         
                      
               }
          break;
                    

           case WM_CHAR:
                 taste = (char) wParam;
                 // Sprungtasten
                 if ( taste == 'd' ) {
                    static_z = TRUE;
                 }
                 if ( taste == 'f' ) {
                    static_z = FALSE;
                 }
                 if ( taste == 'h' ) {
                    save2_x = world_xpos;
                    save2_y = world_ypos;
                 }
                 if ( taste == 'j' ) {
                    save3_x = world_xpos;
                    save3_y = world_ypos;
                 }
                 if ( taste == 'b' ) {
                    world_xpos = save1_x;
                    world_ypos = save1_y;
                    reload_it = TRUE;
                 }
                 if ( taste == 'n' ) {
                    world_xpos = save2_x;
                    world_ypos = save2_y;
                    reload_it = TRUE;
                 }
                 if ( taste == 'm' ) {
                    world_xpos = save3_x;
                    world_ypos = save3_y;
                    reload_it = TRUE;
                 }          
                 if ( taste == '6' ) {
                     world_xpos++;
                     reload_it = TRUE;
                 }
                 if ( taste == '4' ) {
                     world_xpos--;
                     reload_it = TRUE;
                 }
                 if ( taste == '8' ) {
                      world_ypos--;
                      reload_it = TRUE;
                 }
                 if ( taste == '2' ) {
                       world_ypos++;
                       reload_it = TRUE;
                 }
                 if ( taste == '7' ) {
                       view_zpos = view_zpos - 20;
                 }
                 if ( taste == '1' ) {
                       view_zpos = view_zpos + 20;
                 }
                 if ( taste == '9' ) {
                       view_ypos = view_ypos - 5;
                 }
                 if ( taste == '3' ) {
                       view_ypos = view_ypos + 5;
                 }          
                 if ( taste == 'q' ) {
                       riselevel = 1;
                 }                  
                 if ( taste == 'w' ) {
                      riselevel = 10;
                 }          
                 if ( taste == 'o' ) {
                      drawmode = 1;
                 }                      
                 if ( taste == 'p' ) {
                      drawmode = 2;
                 }
                 if ( taste == 'i' ) {
                      drawmode = 3;
                 }
                 if ( taste == 'u' ) {
                      drawmode = 4;
                 }
                 if ( taste == '+' ) {
                       xdim++;
                       ydim++;
                       reload_it = TRUE;
                 }
                 if ( taste == '-' ) {
                       xdim--;
                       ydim--;
                       reload_it = TRUE;
                 }                 
                 break;     

           case WM_SIZE:
                  if ( device3d.param.active ) {
                       device3d.rebuild();
                  }
                  break;

          case WM_MOVE:
                  if ( device3d.param.active ) {
                       device3d.rebuild();
                  }
                  break;

          case WM_DESTROY:
                    //programRelease();
                    PostQuitMessage (0);
                  break;

          default:
                  break;
    }

    return DefWindowProc( hWnd, message, wParam, lParam);
}

void WinInit( HINSTANCE hInst ) {
    // Register the window class
    WNDCLASS wndClass = { CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInst,
                          LoadIcon( hInst, NULL ),
                          LoadCursor(NULL, IDC_ARROW), 
                          (HBRUSH)GetStockObject(WHITE_BRUSH), NULL,
                          TEXT("Window") };
    RegisterClass( &wndClass );
    
    // Create our main window
    hWnd = CreateWindow( TEXT("Window"),
                              TEXT("Uo3dmv R.6. (C) 1999 by LXD "),
                              WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
                              CW_USEDEFAULT, 640, 480, 0L, 0L, hInst, 0L );
    ShowWindow( hWnd, SW_SHOWNORMAL );
    UpdateWindow( hWnd );
}

int get_map( int x, int y ) {
    int i;
    BOOL IsThere2;
    int Where2;
    IsThere2 = FALSE;
    // berprfen ob es schon in der Liste ist
    for ( i = 0; i < omap_pos;i++) {
        if ( omap[i].x == x ) 
         if ( omap[i].y == y) {
             IsThere2 = TRUE;
             Where2 = i;
         }
    }
    if ( IsThere2 ) return Where2;
     else {
         if ( omap_pos < 5000 ) {
             Where2 = omap_pos;
             omap[omap_pos].x = x;
             omap[omap_pos].y = y;
             omap[omap_pos].object = original_object;
             omap[omap_pos].type1 = original_pos;
             omap_pos++;
             return Where2;
         } else {
             return 100000;
         }
     }
}

#include "draws.h"


void init_prog() {
    int i;
    for ( i = 0; i < tile_anzahl;i++) tile[i] = NULL;
    tile_memory = malloc(1000000);
    tile_transform_memory = malloc(1000000);
    tile_scale_memory = malloc(1000000);
    static_memory = malloc(1000000);
    Map_Ground = malloc(1300000);
    world_xpos = 180;
    world_ypos = 200;
    view_zpos = 0;
    view_ypos = 0;
    make_addmatrix();
    reload_it = TRUE;
    perspektive = 0;
    arot = 0;
    brot = 0;
    crot = 0;     
}

void deinit_prog() {
    free( tile_memory ); 
    free( tile_transform_memory );
    free( tile_scale_memory);
    free( static_memory );
}

void load_cfg() {
    int handle;
    int data;
    handle = open("uo3dmv.cfg", O_RDONLY | O_BINARY );

    // Standardkonfig
    cfg_mode = 1;
    cfg_driver = 1;
    cfg_tile = 3;
    cfg_static = 4;
    cfg_zbuffer = 1;
    data = 0;

    // 1-Windowed    2-Fullscreen
    read(handle,&data,4);
    if ( data == 1 ) cfg_mode = 1;
    if ( data == 2 ) cfg_mode = 2;

    // 1-Hardware    2-Software
    read(handle,&data,4);
    if ( data == 1 ) cfg_driver = 1;
    if ( data == 2 ) cfg_driver = 2;

    // Tile  1-8x8    2-16x16   3-32x32
    read(handle,&data,4);
    if ( data == 1 ) cfg_tile = 8;
    if ( data == 2 ) cfg_tile = 16;
    if ( data == 3 ) cfg_tile = 32;

    // Static  1-8x8     2-16x16    3-32x32    4-64x64     5-128x128
    read(handle,&data,4);
    if ( data == 1 ) cfg_static = 8;
    if ( data == 2 ) cfg_static = 16;
    if ( data == 3 ) cfg_static = 32;
    if ( data == 4 ) cfg_static = 64;
    if ( data == 5 ) cfg_static = 128;

    // Z-Buffer   1-ein   2-aus
    read(handle,&data,4);
    if ( data == 1 ) cfg_zbuffer = 1;
    if ( data == 2 ) cfg_zbuffer = 2;

    
    close( handle );
}


// WinMain
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR strCmdLine, INT ) {
    int i6;
    MSG msg;

    load_cfg();
  
    device3d.param.mode = cfg_mode;
    device3d.param.driver = cfg_driver;
    device3d.param.texturemanage = 2;
    device3d.param.active = FALSE;
    for ( i6 = 0; i6 < static_anzahl;i6++) staticsurface[i6] = NULL;

    // Vorkonfiguration
    if ( device3d.param.driver == 2 ) {
        xdim = 15;
        ydim = 15;
    }
    
    WinInit( hInst );
    
    device3d.init ( hWnd );
    init_prog();
    device3d.clear();   
    load_tiles();
    //load_quality_tiles();
    draw_scene();
    device3d.flip();

    // Warteschleife
    while (1) {
        if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE)) {
            if( !GetMessage( &msg, NULL,0 ,0)) {
                break;
            }
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
        else {
           
           //WaitMessage();
            
        }
     device3d.clear();   
     draw_scene();
     device3d.flip();
    }
    deinit_prog();
    device3d.deinit();
    

    return 0;
}
